(ns wanijo.schema.middleware
  (:require [wanijo.schema.domain :as domain]
            [wanijo.framework.common :refer [in?]]))

(defn wrap-user-schemas [handler]
  (fn [req]
    (if-let [uuid (get-in req [:session :uuid])]
      (let [created (domain/all-created-by! uuid)
            created-uids (map :uuid created)
            others (filter (fn [other]
                             (not (in? created-uids (:uuid other))))
                           (domain/all!))]
        (handler (-> req
                     (assoc-in [:session :created-schemas] created)
                     (assoc-in [:session :other-schemas] others))))
      (handler req))))
